import java.sql.Connection;
import java.sql.DriverManager;
import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.atomic.AtomicLong;

public class GetConnectionTestWorking {
    public static void main(String[] args) throws Exception {
        Class.forName("nl.cwi.monetdb.jdbc.MonetDriver");
        String password = args[0];
        AtomicLong counter = new AtomicLong();
        List<Thread> threads = new ArrayList<Thread>();
        for (int i = 0; i < 32; i++) {
            threads.add(new Thread(new DoGetConnection(counter, "jdbc:monetdb://percy-sandbox/click", "monetdb",
                    password)));
        }
        for (Thread thread : threads) {
            thread.start();
        }
        Thread.sleep(10000);
    }

    private static class DoGetConnection implements Runnable {
        private AtomicLong counter;
        private String url;
        private String username;
        private String password;

        public DoGetConnection(AtomicLong counter, String url, String username, String password) {
            super();
            this.counter = counter;
            this.url = url;
            this.username = username;
            this.password = password;
        }

        public void run() {
            try {
                Connection conn;
                synchronized (counter) {
                    conn = DriverManager.getConnection(url, username, password);
                }
                try {
                    long finishedCount = counter.incrementAndGet();
                    System.out.println("Finished " + finishedCount);
                } finally {
                    conn.close();
                }
            } catch (Exception e) {
                e.printStackTrace();
            }
        }
    }
}
